"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebpackEslintPlugin = void 0;
const core_1 = require("@zero-scripts/core");
const webpack_config_1 = require("@zero-scripts/webpack-config");
const WebpackEslintPluginOptions_1 = require("./WebpackEslintPluginOptions");
const rr = require.resolve;
let WebpackEslintPlugin = class WebpackEslintPlugin extends core_1.AbstractPlugin {
    apply(applyContext) {
        applyContext.hooks.beforeRun.tap('WebpackEslintPlugin', beforeRunContext => {
            const config = beforeRunContext.getConfigBuilder(webpack_config_1.WebpackConfig);
            config.hooks.build.tap('WebpackEslintPlugin', (modifications, { jsFileExtensions, paths }) => {
                const pluginOptions = this.optionsContainer.build();
                modifications.insertCommonModuleRule({
                    test: core_1.extensionsRegex(jsFileExtensions),
                    include: paths.src,
                    enforce: 'pre',
                    loader: rr('eslint-loader'),
                    options: {
                        eslintPath: rr('eslint'),
                        formatter: rr('eslint-formatter-pretty'),
                        ignore: false,
                        useEslintrc: false,
                        baseConfig: {
                            parser: rr('babel-eslint'),
                            extends: ['eslint:recommended', ...pluginOptions.extends],
                            plugins: ['import', ...pluginOptions.plugins],
                            parserOptions: Object.assign({ ecmaVersion: 9, sourceType: 'module' }, pluginOptions.parserOptions),
                            settings: pluginOptions.settings,
                            env: Object.assign({ browser: true, node: true }, pluginOptions.env),
                            rules: Object.assign({ 'no-unused-vars': 'warn', 'no-console': 'warn' }, pluginOptions.rules),
                            overrides: [
                                {
                                    files: ['*.ts', '*.tsx'],
                                    parser: rr('@typescript-eslint/parser'),
                                    plugins: ['@typescript-eslint'],
                                    rules: {
                                        'no-undef': 'off',
                                        'no-unused-vars': 'off',
                                        'no-restricted-globals': 'off',
                                        'no-use-before-define': 'off',
                                        '@typescript-eslint/no-unused-vars': [
                                            'warn',
                                            {
                                                vars: 'all',
                                                args: 'after-used',
                                                ignoreRestSiblings: false
                                            }
                                        ]
                                    }
                                }
                            ]
                        }
                    }
                }, core_1.InsertPos.Start);
            });
        });
    }
};
WebpackEslintPlugin = __decorate([
    core_1.ReadOptions(WebpackEslintPluginOptions_1.WebpackEslintPluginOptions, 'plugin-webpack-eslint')
], WebpackEslintPlugin);
exports.WebpackEslintPlugin = WebpackEslintPlugin;
//# sourceMappingURL=WebpackEslintPlugin.js.map